// Settings.java

/*
 * Rishi Kacker and Matt Pauker 
 * 05/12/2001
 */

public class Settings {
	
	//Q enums
	public final static int STATIC_DECREASING = 1;
	public final static int STATIC_DECREASING_DISTINCT = 2;
	public final static int DYNAMIC_TRUST = 3;

	//Q parameters
	public final static int MIN_ASSIGNMENTS = 3; // min # of assignments for STATIC_DECREASING_DISTINCT

	//Activity enums
	public final static int VARIABLE_RESOURCES = 1; //growth based on tasks uncompleted
	public final static int VARIABLE_RESOURCES_MAX = 2; //growth up to a max e0
	public final static int CONSTANT_RESOURCES = 3; //no activity or trust

	public final static int MAX_ACTIVITY = 10;
	public final static double MIN_BOUND = 0.000001;
	public final static int CONSTANT_SPEED = 4;
	
	
	//Task parameters
	public final static int NUM_TASKS = 2000000;
	public final static int NUM_TIME_PERIODS = 1000;
	public final static int TASK_PAYMENT = 1;
	
	//Payment enums
	public final static int CONSTANT_PAYMENT = 1;
	public final static int VARIABLE_PAYMENT = 2;

	//Agreement enums
	public final static int UNANIMOUS_AGREEMENT = 1;
	public final static int MAJORITY_AGREEMENT = 2;

	//Probability parameters
	public final static int DEFECTING_UTILITY = 1;  //E
	public final static double DEFECTING_RATION = (double)DEFECTING_UTILITY/TASK_PAYMENT; //e
	public final static double PARTICIPANT_FRACTION = .1; //p
	
	//Registration
	public final static int REGISTRATION_PERIOD = 10; //d
	public final static double STATIC_OVERHEAD = .17;
	
	//Perfectly Secure
	public final static double STATIC_CONSTANT = .1; //c

	private static int qMode;
	private static int activityMode;
	private static int paymentMode;
	private static int agreementMode;
	private static double elasticity;
	 
	public static void SetActivityMode(int activityMode) {Settings.activityMode = activityMode;}
	public static void SetQMode(int qMode) {Settings.qMode = qMode;}
	public static void SetPaymentMode(int paymentMode) {Settings.paymentMode = paymentMode;}
	public static void SetAgreementMode(int agreementMode) {Settings.agreementMode = agreementMode;}
	public static void SetElasticty(double elasticity) {Settings.elasticity = elasticity;}

	public static int GetActivityMode() {return activityMode;}
	public static int GetQMode() {return qMode;}
	public static int GetPaymentMode() {return paymentMode;}
	public static int GetAgreementMode() {return agreementMode;}
	public static double GetElasticity() {return elasticity;}
}
